CON

  _clkmode = xtal1 + pll16x                                                      
  _xinfreq = 5_000_000

  BAUD = 115_200
  
OBJ
  
  F32 : "Float32"
  Pst : "Parallax Serial Terminal"
  Format : "StrFmt"

    
PUB Main | testa
  
  Pst.Start(BAUD)
  F32.Start
  waitcnt(clkfreq / 2 + cnt)
  
  Pst.RxFlush   
  Pst.Clear
  
     
'  waitcnt(clkfreq * 1 + cnt)

  repeat
    Pst.ClearEnd
    Pst.NewLine
    Pst.ClearBelow
    Pst.Home
    
    testa := F32.FAdd(0.7, 0.7)
    Pst.Str(string(13, " float add 0.7+0.7   = "))
    DisplayFloat(testa , 2)
   
    testa := F32.FMul(0.7, 0.7)
    Pst.Str(string(13, " float mul 0.7*0.7   = "))
    DisplayFloat(testa , 2)
    
    testa := F32.FAdd(15.5, 15.5)
    Pst.Str(string(13, " float add 15.5+15.5 = "))
    DisplayFloat(testa , 2)
   
    testa := F32.FMul(15.5, 15.5)
    Pst.Str(string(13, " float mul 15.5*15.5 = "))
    DisplayFloat(testa , 2)
    
    Pst.NewLine
   
    waitcnt(clkfreq + cnt)

PRI DisplayFloat(fValue, decimalPlaces) | fScale

  fScale := F32.Exp10(F32.FFloat(decimalPlaces))
  result := RoundScaled(fValue, fScale)
  DecPoint(result, decimalPlaces)
  
PRI RoundScaled(fValue, fScale)

  result := F32.FRound(F32.FMul(fValue, fScale))
  
PRI DecPoint(value, places) | tempBuffer[4]

  result := Format.FDec(@tempBuffer, value, 9, places)
'  byte[result] := 0
  Pst.Str(@tempBuffer)

